import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import time
import string
import psyco
from xpints import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Environment'
info.version = '1.1.24'
info.basename = '10pintsEnvironment'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'



psyco.full()
'''
It Will allways be assumed that CT's are Zombies and T's are Humans
'''

################################################################################
#						 													  #
#						      Environment Globals                             #
#																			  #
################################################################################
environmentVars = {'rounds':1, 'fails':5,'mapName':'0'}
player = xpints.player()

################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')
	
def unload():
	doshit = 1
	
def round_start(ev):
	environment().mapSetup().checkMode(ev)
	environment().roundSetup().roundSetup(ev)
	environment().setBotCount()
	
def es_map_start(ev):
	environment().mapSetup().getMapName(ev)
	environment().roundSetup().newMap()
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')
	
def player_death(ev):
	environment().death().check(ev)

def round_end(ev):
	environment().roundSetup().newRound(ev)
	
def player_spawn(ev):
	environment().spawn().onSpawn(ev)
	
def player_hurt(ev):
	environment().hurtEvent(ev)
	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################



def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
################################################################################
#						 													  #
#					 	    Environment Class                                 #
#																			  #
################################################################################



class environment:
	def __init__(self):
		pass
		
	def getRoundNum(self):
		return environmentVars['rounds']
		
	def hurtEvent(self,ev):
		victim = ev['userid']
		#if player.getHealth(victim) <= 60:
			#player.setSpeed(victim, .6)
				
	def setBotCount(self):
		teamvar = '#t'
		list = playerlib.getPlayerList(teamvar)
		playerCount = 0
		for player in list:
			playerCount += 1
		bots = 4 + ( 4 * playerCount ) + playerCount
		es.server.queuecmd('bot_quota %s' %bots)
		
	class specialMission:
		def __init__(self):
			pass
			
		def nightMission(self):
			doshit = 1
			
		def doubledUp(self):
			doshit = 1
			
		def round11(self):
			doshit = 1
			
	class roundSetup:
		def __init__(self):
			pass
			
		def roundSetup(self,ev):
			if environmentVars['fails'] >= 0:
				time = environmentVars['rounds']
				if time > 9:
					time = 9
				if environmentVars['rounds'] == 10:
					environmentVars['fails'] = 0
					es.msg("#multi", "#greenFINAL ROUND, Can you turn it up to 11?")
				if environmentVars['rounds'] == 11:
					es.msg("#multi", "#greenRound 11...")
					#doshti for round 11
					
				es.msg("#multi", "#greenYou are now on round " + str(environmentVars['rounds']) + " and have to survive " + str(time) + " minutes")
			else:
				es.server.queuecmd('mp_roundtime 9')
				es.server.queuecmd('mp_freezetime 60')
				maps = ('xp_italy','xp_dust','xp_dust2')
				es.msg("#multi", "#greenStarting Map Vote" )
				gamethread.delayed(10,es.server.queuecmd,('changelevel ' + random.choice(maps))) #temp fix for map problem
				list = playerlib.getPlayerList('#all')
				for players in list:
					player.setSpeed(players.userid, .0000000000000000001)
				
			userid = es.getuserid()
			if userid:
				es.server.queuecmd('es_fire %s game_weapon_manager addoutput "maxpieces 0"' % userid)
			
		def newMap(self):
			environmentVars['rounds'] = 1
			environmentVars['fails'] = 5
			es.server.queuecmd('sv_skyname sky_borealis01')
			es.server.queuecmd('bot_knives_only 1')
			es.server.queuecmd('bot_join_after_player 1')
			es.server.queuecmd('mp_autoteambalance 0')
			es.server.queuecmd('mp_limitteams 0')
			es.server.queuecmd('bot_difficulty 3')
			es.server.queuecmd('bot_quota_mode fill')
			es.server.queuecmd('mp_humanteam t')
			es.server.queuecmd('mp_roundtime 1')
			es.server.queuecmd('bot_kick all')
			classic = es.precachemodel('models/player/pil/classic.mdl')
			fast = es.precachemodel('models/player/pil/fast_v5/pil_fast_v5.mdl')
			corpse = es.precachemodel('models/player/pil/corpse/zombiecorpse.mdl')
			poison = es.precachemodel('models/player/pil/poison/poison.mdl')
			crispy = es.precachemodel('models/player/pil/crispier_v2/crispy.mdl')
			chiefblue = es.precachemodel('models/player/wastedyouth/bluemc/ct_sas.mdl')
			chiefred = es.precachemodel('models/player/wastedyouth/redmc/t_arctic.mdl')
			ucorp = es.precachemodel('models/player/natalya/umbrella_sas/umbrella_sas_rx.mdl')
			ucorpGuerilla = es.precachemodel('models/player/natalya/umbrella_guerilla/umbrella_guerilla.mdl')
			ucorpElite = es.precachemodel('models/player/natalya/umbrella_leet/umbrella_leet.mdl')
			ucorpPheonix = es.precachemodel('models/player/natalya/umbrella_phoenix/umbrella_phoenix.mdl')
			ucorpArtic = es.precachemodel('models/player/natalya/umbrella_arctic/umbrella_arctic.mdl')
			zombieModels = ('player/pil/classic',
				'player/pil/fast_v5/pil_fast_v5',
				'player/pil/corpse/zombiecorpse',
				'player/pil/poison/poison',
				'player/pil/crispier_v2/crispy')
			humanModels = ('player/natalya/umbrella_guerilla/umbrella_guerilla',
				'player/natalya/umbrella_leet/umbrella_leet',
				'player/natalya/umbrella_phoenix/umbrella_phoenix',
				'models/player/natalya/umbrella_arctic/umbrella_arctic')
			
		def newRound(self,ev):
			if ev['winner'] == '2':
				#gamethread.delayed(.01,es.centermsg, 'Humans Win')
				environmentVars['rounds'] += 1
				time = environmentVars['rounds']
				es.server.queuecmd('mp_roundtime %s' %time)
				if environmentVars['rounds'] == 11:
					doshitforlinkingtoround11epicmode = 0
			if ev['winner'] == '3':
				list = playerlib.getPlayerList('#t')
				playerCount = 0
				#gamethread.delayed(.01,es.centermsg, 'Zombies Win')
				for player in list:
					playerCount += 1
				if playerCount > 0:
					environmentVars['fails'] -= 1
					if environmentVars['fails'] == -1:
						es.msg("#multi", "#green----GAME OVER----" )
						es.msg("#multi", "#green----GAME OVER----" )
						es.msg("#multi", "#green----GAME OVER----" )
						es.msg("#multi", "#green----GAME OVER----" )
						es.msg("#multi", "#green----GAME OVER----" )
						es.server.queuecmd('mp_roundtime 9')
						es.server.queuecmd('mp_freezetime 60')
						list = playerlib.getPlayerList('#all')
						for players in list:
							player.setSpeed(players.userid, .0000000000000000001)
				es.msg("#multi", "#greenHumans Failed to Pass round " + str(environmentVars['rounds']) + " and have " + str(environmentVars['fails']) + " Retrys remaining" )
		
	class death:
		def __init__(self):
			pass
		def check(self, ev):
			team = ev['es_userteam']
			if team == '3':
				gamethread.delayed(1,player.spawn,ev['userid'])
	class spawn:
		def __init__(self):
			self.zombieModels = ('player/pil/classic',
				'player/pil/fast_v5/pil_fast_v5',
				'player/pil/corpse/zombiecorpse',
				'player/pil/poison/poison',
				'player/pil/crispier_v2/crispy')
		def onSpawn(self,ev):
			team = ev['es_userteam']
			userid = ev['userid']
			if team == '3':
				try:
					aplayer = playerlib.getPlayer(userid)
					#es.setplayerprop(userid, 'CBasePlayer.m_iDefaultFOV', 160)
					player.addSpeed(userid, .1)
					hp = 75 + (10 * environmentVars['rounds'] )
					player.addHealth(userid, hp)
					aplayer.setArmor(150)
					aplayer.set('model', random.choice(self.zombieModels))
					aplayer.setNightvisionState(1)
					es.server.queuecmd('est_stripplayer %s' %userid)
					es.server.queuecmd('est_give %s weapon_knife' %userid)
					gamethread.delayed(1,aplayer.setWeaponColor,(0, 0, 0, 0))
				except:
					es.dbgmsg(0,'Weapon Color Error, probably a bot that spawned before game start')
	class mapSetup:
		def __init__(self):
			pass
		def getMapName(self,ev):
			environmentVars['mapName'] = ev['mapName']
			
		def checkMode(self,ev):
			userid = es.getuserid()
			es.server.queuecmd('es_xfire %d func_buyzone Disable' % userid)
			if 'xp_' in environmentVars['mapName']:
				self.removeHosties()
			else:
				self.enableCompatabilityMode()
		def enableCompatabilityMode(self):
			userid = es.getuserid()
			es.dbgmsg(0,'Enabling Compatability Mode')
			if len(es.createentitylist('func_bomb_target')):
				es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
				es.server.queuecmd('es_xfire %d weapon_c4 Kill' %userid)
            
			elif len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
			if len(es.createentitylist('func_bomb_target')):
				es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
				es.server.queuecmd('es_xfire %d weapon_c4 Kill' % userid)
			elif len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' % userid)
			es.msg("#green", "This Server is now running the current map in compatability mode")
		def removeHosties(self):
			userid = es.getuserid()
			if len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)



#es_unload xpints;es_load xpints; changelevel cs_office			
##################################################################################################
#EOF
##################################################################################################